Imports System
Imports System.Windows.Forms
Imports System.Text
Imports System.IO
Imports System.Runtime.InteropServices

Namespace PropLoader

    Partial Public Class FormMain

#Region " Declare DLL Functions / Variables "

        <DllImport("Propellent.dll", CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
        Private Shared Sub InitPropellent(ByVal WinHandel As IntPtr, ByVal StorePrefs As Boolean, ByVal PChar As IntPtr)
        End Sub

        <DllImport("Propellent.dll", CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
        Private Shared Sub FinalizePropellent()
        End Sub

        <DllImport("Propellent.dll", CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
        Private Shared Sub DownloadToPropeller(ByVal Filename As StringBuilder, ByVal Command As Byte)
        End Sub

        Private mPropDllLoaded As Boolean = False
        Private mCurrentFile As String = ""

#End Region

#Region " Form "

        Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                InitPropellent(Me.Handle, False, IntPtr.Zero)
            Catch ex As System.Exception
                MessageBox.Show("Propellent.Dll was not Found", String.Empty, MessageBoxButtons.OK, MessageBoxIcon.Error)
                System.Environment.Exit(1)
            End Try
            mPropDllLoaded = True
        End Sub

        Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
            Try
                If mPropDllLoaded = True Then
                    FinalizePropellent()
                End If
            Catch ex As System.Exception
            End Try
        End Sub

#End Region

#Region " Buttons "

        Private Sub btnEEPROM_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnEEPROM.Click
            Download(mCurrentFile, 3)
        End Sub

        Private Sub btnRAM_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnRAM.Click
            Download(mCurrentFile, 1)
        End Sub

        Private Sub btnLoad_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnLoad.Click

            Try
                Dim myOpenDialog As OpenFileDialog = New OpenFileDialog()
                myOpenDialog.DefaultExt = ".binary"
                myOpenDialog.Filter = "BINARY File(*.binary)|*.binary|EEPROM File (*.eeprom)|*.eeprom|All files (*.*)|*.*"
                myOpenDialog.Title = "Load File..."
                If myOpenDialog.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                    If File.Exists(myOpenDialog.FileName) Then
                        mCurrentFile = myOpenDialog.FileName
                        Label1.Text = "Current File: " & Path.GetFileName(myOpenDialog.FileName)
                        btnRAM.Enabled = False
                        btnEEPROM.Enabled = False
                        Select Case Path.GetExtension(myOpenDialog.FileName).ToUpper()
                            Case ".BINARY"
                                btnRAM.Enabled = True
                            Case ".EEPROM"
                                btnEEPROM.Enabled = True
                                btnRAM.Enabled = True
                        End Select
                    End If
                End If
                myOpenDialog.Dispose()
            Catch ex As System.Exception

            End Try

        End Sub

#End Region

#Region " Subs "

        Private Sub Download(ByVal FileName As String, ByVal Mode As Byte)
            Try
                If mPropDllLoaded = True Then
                    DownloadToPropeller(New StringBuilder(FileName), Mode)
                End If
            Catch ex As System.Exception

            End Try
        End Sub

#End Region

    End Class

End Namespace